import { NgModule } from '@angular/core';
import { PreloadAllModules, RouterModule, Routes } from '@angular/router';
import * as Parse from "parse"
const routes: Routes = [
  {
    path: '',
    loadChildren: () => import('./tabs/tabs.module').then(m => m.TabsPageModule)
  },
  {
    path: 'user',
    loadChildren: () => import('../modules/user/user.module').then( m => m.UserModule)
  },
  {
    path: 'test',
    loadChildren: () => import('../modules/test/test.module').then( m => m.TestModule)
  }
  ,
  {
    path: 'ai',
    loadChildren: () => import('../modules/aigc/aigc.module').then( m => m.AigcModule)
  }

];
@NgModule({
  imports: [
    RouterModule.forRoot(routes, { preloadingStrategy: PreloadAllModules })
  ],
  exports: [RouterModule]
})
export class AppRoutingModule {}
