import { Component } from '@angular/core';
import * as Parse from "parse";
import { Platform } from '@ionic/angular';
import { Router } from '@angular/router';
import { OutputService } from './output.service';
import { Interpolation } from '@angular/compiler';
import { count } from 'console';
 
@Component({
  selector: 'app-survey',
  templateUrl: 'mbti-test.page.html',
  styleUrls: ['mbti-test.page.scss'],

})


export class MBTITestPage {
  outputData=new OutputService().outputData;
  surveyName: string = 'MBTI测试';
  timeLeft: number = 1800; // 倒计时时间，单位秒
  minute=Math.floor(this.timeLeft/60)
  second=this.timeLeft%60
  currentQuestionIndex: number = 0;
  totalQuestions: number = this.outputData.length; // 总题数
  progress: number = (this.currentQuestionIndex + 1) / this.totalQuestions;
  personalities = [
    { characteristics: "E", count: 0 },
    { characteristics: "F", count: 0 },
    { characteristics: "T", count: 0 },
    { characteristics: "P", count: 0 },
    { characteristics: "I", count: 0 },
    { characteristics: "N", count: 0 },
    { characteristics: "S", count: 0 },
    { characteristics: "J", count: 0 },
  ];
  isLastQuestion: boolean = false;
  selectOption:any
  selectedOption=new Array();
  
  constructor(private router: Router){
    this.startTimer();
    // this.readFile();
  }

 
  startTimer() {
    let a=setInterval(() => {
      if (this.timeLeft > 0) {
        this.timeLeft--;
        this.minute=Math.floor(this.timeLeft/60)
        this.second=this.timeLeft%60
      } else {
        this.saveAnswer();
        this.submitSurvey();
        clearInterval(a);
      }
    }, 1000);
  }

  former() {
    if (this.currentQuestionIndex > 0) {
      this.currentQuestionIndex--;
      this.selectOption=this.selectedOption[this.currentQuestionIndex];
      this.updateProgress();
    }
  }

  latter() {
    this.saveAnswer();
    
    if (this.currentQuestionIndex < this.totalQuestions-1) {
      this.currentQuestionIndex++;
      this.updateProgress();
    } 
    else {
      this.submitSurvey();
    }
  }

  saveAnswer() {
    // 保存选项到数据库（使用Parse SDK）
    if (this.selectOption !== undefined && this.selectedOption[this.currentQuestionIndex] == undefined) {
      // 将用户选择的选项保存到数据库或其他地方
      this.selectedOption[this.currentQuestionIndex]=this.selectOption;
    }
    if(this.selectedOption[this.currentQuestionIndex+1]==undefined){
      this.selectOption=0;
    }
    if(this.selectedOption[this.currentQuestionIndex+1]!=undefined){
      this.selectOption=this.selectedOption[this.currentQuestionIndex+1]
    }
  }

  submitSurvey() {
    // 提交问卷到数据库（使用Parse SDK）
    var result=this.sumcount();
    //window.location.href = 'http://192.168.137.1:8080/'+result+'.html';
    window.location.href = 'assets/personalities/'+result+'.html'
    this.personalities.forEach(element => {
      console.log(element);
    });
  }

  updateProgress() {
    this.progress = (this.currentQuestionIndex + 1) / this.totalQuestions;
    if (this.progress==1){
      this.isLastQuestion = true;
    }
    else{
      this.isLastQuestion = false;
    }
  }
  sumcount(){
    for(var i=0;i<this.totalQuestions;i++){
      for(var j=0;j<8;j++){
        if(this.selectedOption[i]==this.personalities[j].characteristics){
          this.personalities[j].count++
        }
      }
    }
// 定义characteristics的顺序
const order = ["E", "I", "N", "S", "T", "F", "J", "P"];

// 按照count大小排序personalities数组
    this.personalities.sort((a, b) => b.count - a.count);

// 根据count大小比较characteristics
let result = "";
for (let i = 0; i < order.length; i += 2) {
  const char1 = this.personalities.find((p) => p.characteristics === order[i]);
  const char2 = this.personalities.find((p) => p.characteristics === order[i + 1]);
  
  if (char1 && char2) {
    result += char1.count > char2.count ? char1.characteristics : char2.characteristics;
  }
}
  let user = Parse.User.current();
  if(user?.id){
    user.set("mbti",result)
    user.save()
  }
console.log(result);
return result;
  }
}

